Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.net.telnet
Class TelnetOptionHandler

    java.lang.Object
      org.apache.commons.net.telnet.TelnetOptionHandler

Direct Known Subclasses:
  EchoOptionHandler, SimpleOptionHandler, SuppressGAOptionHandler, TerminalTypeOptionHandler

public abstract class TelnetOptionHandler
extends Object

The TelnetOptionHandler class is the base class to be used for implementing handlers for telnet options.

TelnetOptionHandler implements basic option handling functionality and defines abstract methods that must be implemented to define subnegotiation behaviour.

Author:
  Bruno D'Avanzo

Constructor Summary
`TelnetOptionHandler(int optcode, boolean initlocal, boolean initremote, boolean acceptlocal, boolean acceptremote)` Constructor for the TelnetOptionHandler.

Method Summary
`abstract int[]` | `answerSubnegotiation(int[] suboptionData, int suboptionLength)` Method called upon reception of a subnegotiation for this option coming from the other end.
`boolean` | `getAcceptLocal()` Returns a boolean indicating whether to accept a DO request coming from the other end.
`boolean` | `getAcceptRemote()` Returns a boolean indicating whether to accept a WILL request coming from the other end.
`boolean` | `getInitLocal()` Returns a boolean indicating whether to send a WILL request to the other end upon connection.
`boolean` | `getInitRemote()` Returns a boolean indicating whether to send a DO request to the other end upon connection.
`int` | `getOptionCode()` Returns the option code for this option.
`void` | `setAcceptLocal(boolean accept)` Set behaviour of the option for DO requests coming from the other end.
`void` | `setAcceptRemote(boolean accept)` Set behaviour of the option for WILL requests coming from the other end.
`void` | `setInitLocal(boolean init)` Tells this option whether to send a WILL request upon connection.
`void` | `setInitRemote(boolean init)` Tells this option whether to send a DO request upon connection.
`abstract int[]` | `startSubnegotiationLocal()` This method is invoked whenever this option is acknowledged active on the local end (TelnetClient sent a WILL, remote side sent a DO).
`abstract int[]` | `startSubnegotiationRemote()` This method is invoked whenever this option is acknowledged active on the remote end (TelnetClient sent a DO, remote side sent a WILL).

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TelnetOptionHandler

    public TelnetOptionHandler(int optcode,
                               boolean initlocal,
                               boolean initremote,
                               boolean acceptlocal,
                               boolean acceptremote)

  Constructor for the TelnetOptionHandler. Allows defining desired initial setting for local/remote activation of this option and behaviour in case a local/remote activation request for this option is received.

Parameters:
  `optcode` - - Option code.
  `initlocal` - - if set to true, a WILL is sent upon connection.
  `initremote` - - if set to true, a DO is sent upon connection.
  `acceptlocal` - - if set to true, any DO request is accepted.
  `acceptremote` - - if set to true, any WILL request is accepted.

Method Detail

### getOptionCode

    public int getOptionCode()

  Returns the option code for this option.

  Returns:
    Option code.

### getAcceptLocal

    public boolean getAcceptLocal()

  Returns a boolean indicating whether to accept a DO request coming from the other end.

  Returns:
    true if a DO request shall be accepted.

### getAcceptRemote

    public boolean getAcceptRemote()

  Returns a boolean indicating whether to accept a WILL request coming from the other end.

  Returns:
    true if a WILL request shall be accepted.

### setAcceptLocal

    public void setAcceptLocal(boolean accept)

  Set behaviour of the option for DO requests coming from the other end.

  Parameters:
    `accept` - - if true, subsequent DO requests will be accepted.

### setAcceptRemote

    public void setAcceptRemote(boolean accept)

  Set behaviour of the option for WILL requests coming from the other end.

  Parameters:
    `accept` - - if true, subsequent WILL requests will be accepted.

### getInitLocal

    public boolean getInitLocal()

  Returns a boolean indicating whether to send a WILL request to the other end upon connection.

  Returns:
    true if a WILL request shall be sent upon connection.

### getInitRemote

    public boolean getInitRemote()

  Returns a boolean indicating whether to send a DO request to the other end upon connection.

  Returns:
    true if a DO request shall be sent upon connection.

### setInitLocal

    public void setInitLocal(boolean init)

  Tells this option whether to send a WILL request upon connection.

  Parameters:
    `init` - - if true, a WILL request will be sent upon subsequent connections.

### setInitRemote

    public void setInitRemote(boolean init)

  Tells this option whether to send a DO request upon connection.

  Parameters:
    `init` - - if true, a DO request will be sent upon subsequent connections.

### answerSubnegotiation

    public abstract int[] answerSubnegotiation(int[] suboptionData,
                                               int suboptionLength)

  Method called upon reception of a subnegotiation for this option coming from the other end. Must be implemented by the actual TelnetOptionHandler to specify which response must be sent for the subnegotiation request.

  Parameters:
    `suboptionData` - - the sequence received, whithout IAC SB & IAC SE
    `suboptionLength` - - the length of data in suboption_data

  Returns:
    response to be sent to the subnegotiation sequence. TelnetClient will add IAC SB & IAC SE. null means no response

### startSubnegotiationLocal

    public abstract int[] startSubnegotiationLocal()

  This method is invoked whenever this option is acknowledged active on the local end (TelnetClient sent a WILL, remote side sent a DO). The method is used to specify a subnegotiation sequence that will be sent by TelnetClient when the option is activated.

  Returns:
    subnegotiation sequence to be sent by TelnetClient. TelnetClient will add IAC SB & IAC SE. null means no subnegotiation.

### startSubnegotiationRemote

    public abstract int[] startSubnegotiationRemote()

  This method is invoked whenever this option is acknowledged active on the remote end (TelnetClient sent a DO, remote side sent a WILL). The method is used to specify a subnegotiation sequence that will be sent by TelnetClient when the option is activated.

  Returns:
    subnegotiation sequence to be sent by TelnetClient. TelnetClient will add IAC SB & IAC SE. null means no subnegotiation.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1997-2005 The Apache Software Foundation. All Rights Reserved.